'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = whichTransitionEvent;
/**
 * Copyright (c) 2015-present, Zippy Technologies
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

function whichTransitionEvent() {
  var el = document.createElement('fakeelement');
  var transitions = {
    transition: 'transitionend',
    OTransition: 'oTransitionEnd',
    MozTransition: 'transitionend',
    WebkitTransition: 'webkitTransitionEnd'
  };

  var t = Object.keys(transitions).find(function (key) {
    return el.style[transitions[key]] !== undefined;
  });

  if (t) {
    return transitions[t];
  }

  return 'transitionend';
}