'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fileReadAsDataURL;
/**
 * Copyright (c) 2015-present, Zippy Technologies
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

function fileReadAsDataURL(file) {
  if (typeof FileReader !== 'undefined') {
    return new Promise(function (resolve, reject) {
      var reader = new FileReader();

      reader.addEventListener('load', function () {
        resolve(reader.result);
      });

      reader.readAsDataURL(file);
    });
  }

  return Promise.resolve();
}