'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Copyright (c) 2015-present, Zippy Technologies
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

function getParentWithTranslate(node) {
  var parent = node && node.parentNode;
  var computedStyle = void 0;

  while (parent && parent !== global.document) {
    computedStyle = global.getComputedStyle(parent);
    if (computedStyle.transform !== 'none') {
      return parent;
    }
    parent = parent && parent.parentNode;
  }

  return false;
}

exports.default = getParentWithTranslate;